local title, addonTable = ...

local distinctItemTypes = {}

addonTable.zoomLevelDistances = {
    [5] = 60.0,
    [4] = 90.0,
    [3] = 120.0,
    [2] = 150.0,
    [1] = 180.0,
    [0] = 250.0,
}

addonTable.itemNameLookups = {
    ["Mageroyal"] = "inv_jewelry_talisman_03",
    ["Grave Moss"] = "inv_misc_dust_02",
    ["Wild Steelbloom"] = "inv_misc_flower_01",
    ["Peacebloom"] = "inv_misc_flower_02",
    ["Plaguebloom"] = "inv_misc_flower_02",
    ["Wintersbite"] = "inv_misc_flower_03",
    ["Bruiseweed"] = "inv_misc_herb_01",
    ["Kingsblood"] = "inv_misc_herb_03",
    ["Gloom Weed"] = "inv_misc_herb_05",
    ["Earthroot"] = "inv_misc_herb_07",
    ["Khadgar's Whisker"] = "inv_misc_herb_08",
    ["Silverleaf"] = "inv_misc_herb_10",
    ["Stranglekelp"] = "inv_misc_herb_11",
    ["Fadeleaf"] = "inv_misc_herb_12",
    ["Arthas' Tears"] = "inv_misc_herb_13",
    ["Doom Weed"] = "inv_misc_herb_13",
    ["Blindweed"] = "inv_misc_herb_14",
    ["Goldthorn"] = "inv_misc_herb_15",
    ["Incendia Agave"] = "inv_misc_herb_15",
    ["Gromsblood"] = "inv_misc_herb_16",
    ["Purple Lotus"] = "inv_misc_herb_17",
    ["Sungrass"] = "inv_misc_herb_18",
    ["Firebloom"] = "inv_misc_herb_19",
    ["Black Lotus"] = "inv_misc_herb_blacklotus",
    ["Dreamfoil"] = "inv_misc_herb_dreamfoil",
    ["Icecap"] = "inv_misc_herb_icecap",
    ["Mountain Silversage"] = "inv_misc_herb_mountainsilversage",
    ["Plaguebloom"] = "inv_misc_herb_plaguebloom",
    ["Golden Sansam"] = "inv_misc_herb_sansamroot",
    ["Briarthorn"] = "inv_misc_root_01",
    ["Liferoot"] = "inv_misc_root_02",
    ["Violet Tragan"] = "inv_mushroom_06",
    ["Ghost Mushroom"] = "inv_mushroom_08",
    ["Copper Vein"] = "inv_ore_copper_01",
    ["Gold Vein"] = "inv_ore_copper_01",
    ["Ooze Covered Gold Vein"] = "inv_ore_copper_01",
    ["Iron Deposit"] = "inv_ore_iron_01",
    ["Mithril Deposit"] = "inv_ore_mithril_02",
    ["Ooze Covered Mithril Deposit"] = "inv_ore_mithril_02",
    ["Incendicite Mineral Vein"] = "inv_ore_thorium_01",
    ["Lesser Bloodstone Deposit"] = "inv_ore_thorium_01",
    ["Ooze Covered Thorium Vein"] = "inv_ore_thorium_02",
    ["Rich Thorium Vein"] = "inv_ore_thorium_02",
    ["Small Thorium Vein"] = "inv_ore_thorium_02",
    ["Tin Vein"] = "inv_ore_tin_01",
    ["Ooze Covered Truesilver Deposit"] = "inv_ore_truesilver_01",
    ["Truesilver Deposit"] = "inv_ore_truesilver_01",
    ["Ooze Covered Silver Vein"] = "inv_stone_16",
    ["Silver Vein"] = "inv_stone_16",
    ["Quest"] = "Quest",
}

addonTable.iconLookups = {
    ["inv_jewelry_talisman_03"] = 133436,
    ["inv_misc_dust_02"] = 133849,
    ["inv_misc_flower_01"] = 133938,
    ["inv_misc_flower_02"] = 133939,
    ["inv_misc_flower_03"] = 133940,
    ["inv_misc_herb_blacklotus"] = 134202,
    ["inv_misc_herb_dreamfoil"] = 134204,
    ["inv_misc_herb_icecap"] = 134212,
    ["inv_misc_herb_mountainsilversage"] = 134215,
    ["inv_misc_herb_plaguebloom"] = 134215,
    ["inv_misc_herb_sansamroot"] = 134221,
    ["inv_misc_herb_01"] = 134181,
    ["inv_misc_herb_03"] = 134182,
    ["inv_misc_herb_05"] = 134184,
    ["inv_misc_herb_07"] = 134186,
    ["inv_misc_herb_08"] = 134188,
    ["inv_misc_herb_10"] = 134190,
    ["inv_misc_herb_11"] = 134191,
    ["inv_misc_herb_12"] = 134192,
    ["inv_misc_herb_13"] = 134193,
    ["inv_misc_herb_14"] = 134194,
    ["inv_misc_herb_15"] = 134195,
    ["inv_misc_herb_16"] = 134196,
    ["inv_misc_herb_17"] = 134197,
    ["inv_misc_herb_18"] = 134198,
    ["inv_misc_herb_19"] = 134199,
    ["inv_misc_root_01"] = 134412,
    ["inv_misc_root_02"] = 134413,
    ["inv_mushroom_06"] = 134527,
    ["inv_mushroom_08"] = 134529,
    ["inv_ore_copper_01"] = 134566,
    ["inv_ore_iron_01"] = 134572,
    ["inv_ore_mithril_02"] = 134576,
    ["inv_ore_thorium_01"] = 134577,
    ["inv_ore_thorium_02"] = 134578,
    ["inv_ore_truesilver_01"] = 134580,
    ["inv_ore_tin_01"] = 134579,
    ["inv_stone_16"] = 135242,
    ["Quest"] = 132049,
}

function addonTable:InitalizeItemTypes()
    processItems(1)
    processItems(3)
    processItems(4)
    processItems(8)
    processItems(10)
    processItems(11)
    processItems(12)
    processItems(14)
    processItems(15)
    processItems(16)
    processItems(17)
    processItems(28)
    processItems(33)
    processItems(36)
    processItems(38)
    processItems(40)
    processItems(44)
    processItems(45)
    processItems(46)
    processItems(47)
    processItems(51)
    processItems(85)
    processItems(130)
    processItems(139)
    processItems(141)
    processItems(148)
    processItems(215)
    processItems(267)
    processItems(331)
    processItems(357)
    processItems(361)
    processItems(400)
    processItems(405)
    processItems(406)
    processItems(440)
    processItems(490)
    processItems(618)
    processItems(1377)
    processItems(1519)
    processItems(1537)
    processItems(1497)
    processItems(1638)
    processItems(1637)
    processItems(1657)
    processItems(493)
end

function processItems(areaID)
    for _, items in ipairs(addonTable.items[areaID]) do
        if(addonTable:itemExists(items[3]) == false) then
            table.insert(distinctItemTypes, items[3])
        end
    end
end

function  addonTable:GetDistinctItemTypes()
    return distinctItemTypes
end

function addonTable:itemExists(item)
    for index, itemName in ipairs(distinctItemTypes) do
        if(itemName == item) then
            return true
        end
    end

    return false
end