local addonName, addonTable = ...

addonTable.zoneLookups = {}

local areasWithIDAndMapID = {
    {"Alterac Mountains", 36, 15},
    {"Alterac Valley", 2597, 401},
    {"Arathi Basin", 3358, 461},
    {"Arathi Highlands", 45, 16},
    {"Ashenvale", 331, 43},
    {"Azeroth", 0, 14},
    {"Azshara", 16, 181},
    {"Badlands", 3, 17},
    {"Blasted Lands", 4, 19},
    {"Burning Steppes", 46, 29},
    {"Darkshore", 148, 42},
    {"Darnassus", 1657, 381},
    {"Deadwind Pass", 41, 32},
    {"Desolace", 405, 101},
    {"Dun Morogh", 1,27},
    {"Durotar", 14, 4},
    {"Duskwood", 10, 34},
    {"Dustwallow Marsh", 15, 141},
    {"Eastern Plaguelands", 139, 23},
    {"Elwynn Forest", 12, 30},
    {"Felwood", 361, 182},
    {"Feralas", 357, 121},
    {"Hillsbrad Foothills", 267, 24},
    {"Ironforge", 1537, 341},
    {"Kalimdor", 0, 13},
    {"Loch Modan", 38, 35},
    {"Moonglade", 493, 241},
    {"Mulgore", 215, 9},
    {"Orgrimmar", 1637, 321},
    {"Redridge Mountains", 44, 36},
    {"Searing Gorge", 51, 28},
    {"Silithus", 1377, 261},
    {"Silverpine Forest", 130, 21},
    {"Stonetalon Mountains", 406, 81},
    {"Stormwind City", 1519, 301},
    {"Stranglethorn Vale", 33, 37},
    {"Swamp Of Sorrows", 8, 38},
    {"Tanaris", 440, 161},
    {"Teldrassil", 141, 41},
    {"The Barrens", 17, 11},
    {"The Hinterlands", 47, 26},
    {"Thousand Needles", 400, 61},
    {"Thunder Bluff", 1638, 362},
    {"Tirisfal Glades", 85, 20},
    {"Undercity", 1497, 382},
    {"Un'Goro Crater", 490, 201},
    {"Warsong Gulch", 3277, 443},
    {"Western Plaguelands", 28, 22},
    {"Westfall", 40, 39},
    {"Wetlands", 11, 40},
    {"Winterspring", 618, 281}
}

local areasWithUiMapIDAndParentUiMapID = {
    -- Area name = { UiMapID, ParentUiMapID }
    ["Alterac Mountains"] = {1416, 1415},
    ["Alterac Valley"] = {1459, 947},
    ["Arathi Basin"] = {1461, 947},
    ["Arathi Highlands"] = {1417, 1415},
    ["Ashenvale"] = {1440, 1414},
    ["Azeroth"] = {947,0},
    ["Azshara"] = {1447, 1414},
    ["Badlands"] = {1418, 1415},
    ["Blasted Lands"] = {1419, 1415},
    ["Burning Steppes"] = {1428, 1415},
    ["Darkshore"] = {1439, 1414},
    ["Darnassus"] = {1457, 1414},
    ["Deadwind Pass"] = {1430, 1415},
    ["Desolace"] = {1443, 1414},
    ["Dun Morogh"] = {1426, 1415},
    ["Durotar"] = {1411, 1414},
    ["Duskwood"] = {1431, 1415},
    ["Dustwallow Marsh"] = {1445, 1414},
    ["Eastern Kingdoms"] = {1415, 947},
    ["Eastern Plaguelands"] = {1423, 1415},
    ["Elwynn Forest"] = {1429, 1415},
    ["Felwood"] = {1448, 1414},
    ["Feralas"] = {1444, 1414},
    ["Hillsbrad Foothills"] = {1424, 1415},
    ["Ironforge"] = {1455, 1415},
    ["Kalimdor"] = {1414, 947},
    ["Loch Modan"] = {1432, 1415},
    ["Moonglade"] = {1450, 1414},
    ["Mulgore"] = {1412, 1414},
    ["Orgrimmar"] = {1454, 1414},
    ["Redridge Mountains"] = {1433, 1415},
    ["Searing Gorge"] = {1427, 1415},
    ["Silverpine Forest"] = {1421, 1415},
    ["Silithus"] = {1451, 1414},
    ["Stonetalon Mountains"] = {1442, 1414},
    ["Stormwind City"] = {1453, 1415},
    ["Stranglethorn Vale"] = {1434, 1415},
    ["Swamp Of Sorrows"] = {1435, 1415},
    ["Tanaris"] = {1446, 1414},
    ["Teldrassil"] = {1438, 1414},
    ["The Barrens"] = {1413, 1414},
    ["The Hinterlands"] = {1425, 1415},
    ["Thousand Needles"] = {1441, 1414},
    ["Thunder Bluff"] = {1456, 1414},
    ["Tirisfal Glades"] = {1420, 1415},
    ["Undercity"] = {1458, 1415},
    ["Un'Goro Crater"] = {1449, 1414},
    ["Warsong Gulch"] = {1460, 947},
    ["Western Plaguelands"] = {1422, 1415},
    ["Westfall"] = {1436, 1415},
    ["Wetlands"] = {1437, 1415},
    ["Winterspring"] = {1452, 1414},
}

local areaIDsWithAreaName = {
    [1] = 'Dun Morogh',
    [3] = 'Badlands',
    [4] = 'Blasted Lands',
    [8] = 'Swamp of Sorrows',
    [10] = 'Duskwood',
    [11] = 'Wetlands',
    [12] = 'Elwynn Forest',
    [14] = 'Durotar',
    [15] = 'Dustwallow Marsh',
    [16] = 'Azshara',
    [17] = 'The Barrens',
    [28] = 'Western Plaguelands',
    [33] = 'Stranglethorn Vale',
    [36] = 'Alterac Mountains',
    [38] = 'Loch Modan',
    [40] = 'Westfall',
    [41] = 'Deadwind Pass',
    [44] = 'Redridge Mountains',
    [45] = 'Arathi Highlands',
    [46] = 'Burning Steppes',
    [47] = 'The Hinterlands',
    [51] = 'Searing Gorge',
    [85] = 'Tirisfal Glades',
    [130] = 'Silverpine Forest',
    [139] = 'Eastern Plaguelands',
    [141] = 'Teldrassil',
    [148] = 'Darkshore',
    [209] = 'Shadowfang Keep',
    [215] = 'Mulgore',
    [267] = 'Hillsbrad Foothills',
    [331] = 'Ashenvale',
    [357] = 'Feralas',
    [361] = 'Felwood',
    [400] = 'Thousand Needles',
    [405] = 'Desolace',
    [406] = 'Stonetalon Mountains',
    [440] = 'Tanaris',
    [490] = 'Un\'Goro Crater',
    [491] = 'Razorfen Kraul',
    [493] = 'Moonglade',
    [618] = 'Winterspring',
    [717] = 'The Stockade',
    [718] = 'Wailing Caverns',
    [719] = 'Blackfathom Deeps',
    [721] = 'Gnomeregan',
    [722] = 'Razorfen Downs',
    [796] = 'Scarlet Monastery',
    [1176] = 'Zul\'Farrak',
    [1337] = 'Uldaman',
    [1377] = 'Silithus',
    [1417] = 'The Temple of Atal\'Hakkar',
    [1477] = 'The Temple of Atal\'Hakkar',
    [1497] = 'Undercity',
    [1519] = 'Stormwind City',
    [1537] = 'Ironforge',
    [1581] = 'The Deadmines',
    [1583] = 'Lower Blackrock Spire',
    [1584] = 'Blackrock Depths',
    [1585] = 'Blackrock Depths',
    [1637] = 'Orgrimmar',
    [1638] = 'Thunder Bluff',
    [1657] = 'Darnassus',
    [1977] = 'Zul\'Gurub',
    [2017] = 'Stratholme',
    [2057] = 'Scholomance',
    [2100] = 'Maraudon',
    [2159] = 'Onyxia\'s Lair',
    [2257] = 'Deeprun Tram',
    [2437] = 'Ragefire Chasm',
    [2557] = 'Dire Maul',
    [2597] = 'Alterac Valley',
    [2677] = 'Blackwing Lair',
    [2717] = 'Molten Core',
    [2917] = 'Hall of Legends',
    [2918] = 'Champions\' Hall',
    [3277] = 'Warsong Gulch',
    [3358] = 'Arathi Basin',
    [3428] = 'Ahn\'Qiraj',
    [3429] = 'Ruins of Ahn\'Qiraj',
    [3456] = 'Naxxramas',
    [7307] = 'Upper Blacrock Spire',
}

function addonTable:InitZoneLookups()
    for index, areaWithIDAndMapID in ipairs(areasWithIDAndMapID) do
        local areaName = areaWithIDAndMapID[1]
        local UiMapID = areasWithUiMapIDAndParentUiMapID[areaName][1]
        addonTable.zoneLookups[UiMapID] = areaWithIDAndMapID[2]
    end
end

function addonTable:GetMapAndAreaID()
    local mapID = addonTable:GetCurrentZone()
    local areaID = addonTable.zoneLookups[mapID]

    if(areaID == nil) then
        areaID = mapID
    end

    return mapID, areaID
end